<!DOCTYPE HTML>
<html>
	<head>
		<title>Quiz Session</title>
		 
		<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
  		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  		<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
  		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
  		
  		<style>
  			.hidden {
  				display: none;
  			}
  		</style>
  		
	</head>
	<body>
		<form>
			<input id="messageType" type="text">
			<input onclick="sendMessage();" value="Send Message" type="button">
			<input id="answerID"    type="text">
			<input onclick="addAnswerID();" value="Add answer ID" type="button">
		</form>
		<br>
		
		<textarea id="messagesTextArea" rows="20" cols="50"></textarea>
		
		
		<div class="row questionTemplate hidden">
  			<div class="col-12">
  				<div class="row">
  					<div class="col-1"></div>
  					<div class="col-10 questionText">WAIT TO LOAD</div>
  					<div class="col-1"></div>
  				</div>
  				<div class="row">
  					<div class="col-12 answersBox">
  					</div>
  				</div>
  			</div>
  		</div>
		
		
		
		<div class="row answerTemplate hidden" answerID="">
  			<div class="col-1">
  				<input class="answerCheckbox" type="checkbox" name="answerCheck">
  			</div>
  			<div class="col-1"></div>
  			<div class="col-8 answerText">GENERIC ANSWER TEXT</div>
  			<div class="col-2"></div>
  		</div>
  		
  		
		
		
		<div class="container quizSession">
  		</div>
		
	</body>
	
	<script type="text/javascript">

	

		var quizID = 1;

		var webSocket = new WebSocket("ws://localhost:8080/RWA_project/quiz/" + quizID);
		var messagesTextArea = document.getElementById("messagesTextArea");
		var messageType = document.getElementById("messageType");
		var answerID = document.getElementById("answerID");

		var userMessage = { messageType: "1", answerIDs: []}

		webSocket.onopen = function(message) { processOpen(message); };
		webSocket.onmessage = function(message) { processMessage(message); }
		webSocket.onclose = function(messages) { processClose(message); };
		webSocket.onerror = function(messages) { processError(message); };

		function processOpen(message) {
			messagesTextArea.value += "Server Connected..." + "\n";
		}

		
		function processMessage(message) {

			var quizMessage = JSON.parse(message.data);
			
			messagesTextArea.value += "Recevied from server ==> " + message.data + "\n";

			var quizSession = document.getElementsByClassName("quizSession")[0];
			var questionTemplate = document.getElementsByClassName("questionTemplate")[0];
			var answerTemplate = document.getElementsByClassName("answerTemplate")[0];


			var question = questionTemplate.cloneNode(true);
			var questionText = question.getElementsByClassName("questionText")[0];
			var answersBox = question.getElementsByClassName("answersBox")[0];

			while (quizSession.firstChild)
			    quizSession.removeChild(quizSession.firstChild);

			question.classList.remove("hidden");
			questionText.textContent = quizMessage.question.questionText;
			questionText.setAttribute('style', 'white-space: pre;');
			
			var answerListLength =  quizMessage.question.answerCollection.length;
			for(var idx = 0; idx < answerListLength; ++idx)
			{
				var answer = answerTemplate.cloneNode(true);

				answer.classList.remove("hidden");
				answer.setAttribute("answerID", quizMessage.question.answerCollection[idx].answerID); 
				answer.getElementsByClassName("answerText")[0].textContent = quizMessage.question.answerCollection[idx].answerText;
				answersBox.appendChild(answer);
			}

			quizSession.appendChild(question);
		
		}

		function processClose(message) {
			webSocket.send("Client disconnected...");
			messagesTextArea.value += "Server disconnected..." + "\n";
		}

		function processError(message) {
			messagesTextArea.value += "Error..." + "\n";
		}


		function sendGetQuestionMessage() 
		{
			userMessage.messageType = messageType.value;
			userMessage.answerIDs = [];

			var userMessageJSON = JSON.stringify(userMessage);
			webSocket.send(userMessageJSON);

			messagesTextArea.value += "Send to server ==> " + userMessageJSON + "\n";
			messageType.value = "";

			userMessage.messageType = "";
		}

		
		function sendMessage() {
			if(!isNaN(messageType.value))
			{
				if(messageType.value == 1)
				{
					sendGetQuestionMessage();
					return;
				}
				
				var quizSession = document.getElementsByClassName("quizSession")[0];
				var question = quizSession.getElementsByClassName("questionTemplate")[0];
				var answersBox =  question.getElementsByClassName("answersBox")[0];
				var answers = answersBox.getElementsByClassName("answerTemplate");
				
				var answerListLength =  answers.length;
				for(var idx = 0; idx < answerListLength; ++idx)
				{
					if(answers[idx].getElementsByClassName("answerCheckbox")[0].checked)
						userMessage.answerIDs.push(answers[idx].getAttribute("answerID"));
				}
				
				userMessage.messageType = messageType.value;

				var userMessageJSON = JSON.stringify(userMessage);
				webSocket.send(userMessageJSON);

	
				messagesTextArea.value = "Send to server ==> " + userMessageJSON + "\n";
				messageType.value = "";

				userMessage.messageType = "";
				userMessage.answerIDs = [];
			}
		}

		

		function addAnswerID() {
			if(!isNaN(answerID.value)) {
				userMessage.answerIDs.push(answerID.value);
				answerID.value = "";
			}

		}
	
		
		
	</script>
	
</html>